//guitar.cs
datablock AudioProfile(drillStartSound)
{
   filename    = "./drillStart.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(drillHitSound)
{
   filename    = "./drillHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(drillActiveSound)
{
   filename    = "./drillActive.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(drillEndSound)
{
   filename    = "./drillEnd.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(drillExplosion : hammerExplosion)
{
   soundProfile = drillHitSound;

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};


//projectile
AddDamageType("drill",   '<bitmap:add-ons/weapon_power_drill/ci_drill> %1',    '%2 <bitmap:add-ons/weapon_power_drill/ci_drill> %1',1,1);
datablock ProjectileData(drillProjectile)
{
   directDamage        = 12;
   impactImpulse       = 20;
   verticalImpulse     = 20;
   directDamageType  = $DamageType::drill;
   radiusDamageType  = $DamageType::drill;
   explosion           = drillExplosion;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 85;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
};

datablock ParticleData(drillSmokeParticleB)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.4;

	useInvAlpha = true;
};

datablock ParticleEmitterData(drillSmokeEmitterB)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 4;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0;
   thetaMin         = 270;
   thetaMax         = 270;
   phiReferenceVel  = 0;
   phiVariance      = 30;
   overrideAdvance = false;
   particles = "drillSmokeParticleB";

   uiName = "drill Smoke B";
};


//////////
// item //
//////////
datablock ItemData(drillItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./powerDrill.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Power Drill";
	iconName = "./icon_drill";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = drillImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(drillImage)
{
   // Basic Item properties
   shapeFile = "./powerDrill.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   //rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = drillItem;
   ammo = " ";
   projectile = drillProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = true;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0 0 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]		= 0.05;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = drillStartSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "preFire";
	stateAllowImageChange[1]	= true;
	stateTimeoutValue[1]		= 0.1;
	stateTransitionOnTimeout[1]	= "Ready";
	stateSequence[1]		= "Ready";
	stateSound[1]			= drillEndSound;

	stateName[2]			= "preFire";
	stateAllowImageChange[2]	= true;
	stateTimeoutValue[2]		= 0.05;
	stateSequence[2]		= "TrigDown";
	stateTransitionOnTimeout[2]	= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateSound[2]			= drillStartSound;	
	
	stateName[3]			= "Fire";
	stateScript[3]			= "onFire";
	stateFire[3]			= true;
	stateAllowImageChange[3]	= true;
	stateTimeoutValue[3]		= 0.10;
	stateTransitionOnTimeout[3]	= "Fire";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateSound[3]			= drillActiveSound;
	stateSequence[3]		= "TrigDown";
	stateEmitter[3]			= drillSmokeEmitterB;
	stateEmitterNode[3]		= everything;
	stateEmitterTime[3]		= 0.2;
};

function drillImage::onFire(%this, %obj, %slot)
{
   %this.melee = 1;
   Parent::onFire(%this, %obj, %slot);
   %this.melee = 0;
   %obj.playThread(2,plant);
}